.386P

EXTRN _asm1 : dword
EXTRN _asm2 : dword
EXTRN _asm3 : dword
EXTRN _asm4 : dword
EXTRN _board2d : near
EXTRN _waloff : near
EXTRN loadtile_ : near

CODE SEGMENT BYTE PUBLIC USE32 'CODE'
ASSUME cs:CODE

PUBLIC setupdrawbpl_
setupdrawbpl_:
	mov dword ptr ds:[machbpl1+2], eax
	mov dword ptr ds:[machbpl2+2], eax
	mov dword ptr ds:[machbpl3+2], eax
	mov dword ptr ds:[machbpl4+2], eax
	mov dword ptr ds:[machbpl5a+2], eax
	mov dword ptr ds:[machbpl5b+2], eax
	ret

PUBLIC setupdrawbackmach_
setupdrawbackmach_:
	rol eax, 8
	rol ebx, 8
	mov byte ptr ds:[machx2+2], al
	mov byte ptr ds:[machx4+2], al
	mov byte ptr ds:[machy2+1], bl
	mov byte ptr ds:[machy4+2], bl
	and eax, 0ffff0000h
	and ebx, 0ffff0000h
	mov dword ptr ds:[machx1+2], eax
	mov dword ptr ds:[machx3+2], eax
	mov dword ptr ds:[machy1+2], ebx
	mov dword ptr ds:[machy3+2], ebx
	ret

PUBLIC drawback_
drawback_:
	;_asm1 = xplc2        ?
	;_asm2 =   ?
	;_asm3 =         boardx1 boardy1
	;_asm4 =         boardx2 boardy2
	;eax =     0        x1   y1
	;ebx =   yplc1     dat2 dat1
	;ecx =   yplc2        cnt
	;edx =     0        x2   y2
	;esi =   xplc1       0e0e0h
	;edi =       videopos

	push ebp

	mov ebp, _asm1
	inc cl
	inc ch
	mov si, 0e0e0h
machbpl1: sub edi, 320

	mov bx, ax
	mov eax, _asm3
	and eax, 00003ffch
	shr eax, 1
	mov ax, word ptr _board2d[eax]
	mov bp, ax
	mov eax, dword ptr _waloff[eax*4]
	test eax, eax
	jnz skiploadtile1
	mov eax, ebp
	and eax, 0000ffffh
	push eax
	call loadtile_
	pop eax
	mov eax, dword ptr _waloff[eax*4]
skiploadtile1:
	mov dword ptr ds:[machbufplc1+2], eax
	mov eax, ebx
	and eax, 0000ffffh

	mov bx, ax
	mov eax, _asm4
	and eax, 00003ffch
	shr eax, 1
	mov ax, word ptr _board2d[eax]
	mov bp, ax
	mov eax, dword ptr _waloff[eax*4]
	test eax, eax
	jnz skiploadtile2
	mov eax, ebp
	and eax, 0000ffffh
	push eax
	call loadtile_
	pop eax
	mov eax, dword ptr _waloff[eax*4]
skiploadtile2:
	mov dword ptr ds:[machbufplc2+2], eax
	mov eax, ebx
	and eax, 0000ffffh

	jmp begvline2
begvline2:
machbpl2: add edi, 320
machbufplc1: mov bl, byte ptr [eax+88888888h]
machx1: add esi, 88880000h
machbufplc2: mov bh, byte ptr [edx+88888888h]
machx2: adc ah, 88h
machy1: add ebx, 88880000h
machy2: adc al, 88h
machx3: add ebp, 88880000h
machx4: adc dh, 88h
machy3: add ecx, 88880000h
machy4: adc dl, 88h
	test eax, 0000e0e0h
	mov word ptr [edi], bx
	jnz fixeax
	test dx, si
	jnz fixedx
	dec cl
	jnz begvline2
	dec ch
	jnz begvline2

endraw32:
	pop ebp
	ret

fixeax:
	mov bx, ax
	sar al, 3
	add al, byte ptr _asm3[0]
	sar ah, 5
	add ah, byte ptr _asm3[1]
	and eax, 00003ffch
	mov dword ptr _asm3, eax
	shr eax, 1
	mov ax, word ptr _board2d[eax]
	mov bp, ax
	mov eax, dword ptr _waloff[eax*4]
	test eax, eax
	jz loadtile3
	mov dword ptr ds:[machbufplc1+2], eax
	mov eax, ebx
	and eax, 00001f1fh

	test dx, si
	jnz fixedx
	dec cl
	jnz begvline2
	dec ch
	jnz begvline2
	jmp endraw32

loadtile3:
	mov eax, ebp
	and eax, 0000ffffh
	push eax
	call loadtile_
	pop eax
	mov eax, ebp
	and eax, 0000ffffh
	mov eax, dword ptr _waloff[eax*4]

	mov dword ptr ds:[machbufplc1+2], eax
	mov eax, ebx
	and eax, 00001f1fh

	test dx, si
	jnz fixedx
	dec cl
	jnz begvline2
	dec ch
	jnz begvline2
	jmp endraw32

fixedx:
	mov bx, ax
	mov eax, edx
	sar al, 3
	add al, byte ptr _asm4[0]
	sar ah, 5
	add ah, byte ptr _asm4[1]
	and eax, 00003ffch
	mov dword ptr _asm4, eax
	shr eax, 1
	mov ax, word ptr _board2d[eax]
	mov bp, ax
	mov eax, dword ptr _waloff[eax*4]
	test eax, eax
	jz loadtile4
	mov dword ptr ds:[machbufplc2+2], eax
	mov eax, ebx
	and edx, 00001f1fh
	and eax, 0000ffffh

	dec cl
	jnz begvline2
	dec ch
	jnz begvline2
	jmp endraw32

loadtile4:
	mov eax, ebp
	and eax, 0000ffffh
	push eax
	call loadtile_
	pop eax
	mov eax, ebp
	and eax, 0000ffffh
	mov eax, dword ptr _waloff[eax*4]
	mov dword ptr ds:[machbufplc2+2], eax
	mov eax, ebx
	and edx, 00001f1fh
	and eax, 0000ffffh

	dec cl
	jnz begvline2
	dec ch
	jnz begvline2
	jmp endraw32


PUBLIC setupdrawspritemach_
setupdrawspritemach_:
	;eax = xinc
	;ebx = yinc
	;ecx = bufplc

	rol eax, 16
	mov byte ptr ds:[machs2+2], al
	mov byte ptr ds:[machsx2a+2], al
	mov byte ptr ds:[machsx4a+2], al
	mov byte ptr ds:[machsx2b+2], al
	mov byte ptr ds:[machsx4b+2], al
	and eax, 0ffff0000h
	mov dword ptr ds:[machs1+1], eax
	mov dword ptr ds:[machsx1a+2], eax
	mov dword ptr ds:[machsx3a+2], eax
	mov dword ptr ds:[machsx1b+2], eax
	mov dword ptr ds:[machsx3b+2], eax

	rol ebx, 16
	mov byte ptr ds:[machs4+2], bl
	mov byte ptr ds:[machsy2a+2], bl
	mov byte ptr ds:[machsy4a+2], bl
	mov byte ptr ds:[machsy2b+2], bl
	mov byte ptr ds:[machsy4b+2], bl
	and ebx, 0ffff0000h
	mov dword ptr ds:[machs3+2], ebx
	mov dword ptr ds:[machsy1a+1], ebx
	mov dword ptr ds:[machsy3a+2], ebx
	mov dword ptr ds:[machsy1b+1], ebx
	mov dword ptr ds:[machsy3b+2], ebx

	mov dword ptr ds:[machs5+2], ecx
	mov dword ptr ds:[machsbufplc1a+2], ecx
	mov dword ptr ds:[machsbufplc2a+2], ecx
	mov dword ptr ds:[machsbufplc1b+2], ecx
	mov dword ptr ds:[machsbufplc2b+2], ecx
	ret

PUBLIC setupsolidspritemach_
setupsolidspritemach_:
	;eax = 1/0
	and al, 1
	shl al, 5
	add al, 0fh
	mov byte ptr ds:[machs6+1], al
	ret

PUBLIC drawspritevline1_
drawspritevline1_:
	;eax =   bx
	;ebx =   by
	;ecx =   cnt     (solidcol) dat
	;edx =   ?
	;esi =   ?
	;edi =   videopos

	xor edx, edx
	rol eax, 16
	mov dh, al
	rol ebx, 16
	mov dl, bl

	jmp begvline1
begvline1:
machs5: mov cl, byte ptr [edx+88888888h]
machs1: add eax, 88880000h
machs2: adc dh, 88h
machs3: add ebx, 88880000h
machs4: adc dl, 88h
	cmp cl, 255
	je skipsvline1
machs6: mov byte ptr [edi], cl
skipsvline1:
machbpl3: add edi, 320
	sub ecx, 65536
	jnc begvline1

	ret

PUBLIC drawspritevline2_
drawspritevline2_:
	;_asm1 = xplc2        ?
	;eax =   yplc1     dat2 dat1    ;NOTE: eax and ebx switched from drawback
	;ebx =     0        x1   y1
	;ecx =   yplc2        cnt
	;edx =     0        x2   y2
	;esi =   xplc1         0
	;edi =       videopos

	push ebp

	mov ebp, _asm1
	inc cl
	inc ch
machbpl4: sub edi, 320

	jmp begsvline2a
begsvline2a:
machbpl5a: add edi, 320
machsbufplc1a: mov al, byte ptr [ebx+88888888h]
machsbufplc2a: mov ah, byte ptr [edx+88888888h]
machsx1a: add esi, 88880000h
machsx2a: adc bh, 88h
machsy1a: add eax, 88880000h
machsy2a: adc bl, 88h
machsx3a: add ebp, 88880000h
machsx4a: adc dh, 88h
machsy3a: add ecx, 88880000h
machsy4a: adc dl, 88h

skipsvline2a:
	cmp al, 255
	je skipsvline2b
	cmp ah, 255
	je skipsvline2c
	mov word ptr [edi], ax
	dec cl
	jnz begsvline2a
	dec ch
	jnz begsvline2a
	jmp svline2end

skipsvline2b:
	cmp ah, 255
	je skipsvline2d
	mov byte ptr [edi+1], ah
	dec cl
	jnz begsvline2a
	dec ch
	jnz begsvline2a
	jmp svline2end

skipsvline2c:
	mov byte ptr [edi], al
	dec cl
	jnz begsvline2a
	dec ch
	jnz begsvline2a

svline2end:
	pop ebp
	ret

begsvline2b:
machbpl5b: add edi, 320
machsbufplc1b: mov al, byte ptr [ebx+88888888h]
machsbufplc2b: mov ah, byte ptr [edx+88888888h]
machsx1b: add esi, 88880000h
machsx2b: adc bh, 88h
machsy1b: add eax, 88880000h
machsy2b: adc bl, 88h
machsx3b: add ebp, 88880000h
machsx4b: adc dh, 88h
machsy3b: add ecx, 88880000h
machsy4b: adc dl, 88h
	cmp ax, 0ffffh
	jne skipsvline2a
skipsvline2d:
	dec cl
	jnz begsvline2b
	dec ch
	jnz begsvline2b
	jmp svline2end

CODE ENDS
END
